script_name("mexer-no-lixo");
script_author("Um_Geek / HybridTheory");
script_url("https://gta-geek.blogspot.com.br/");

local MaxHealt = 0; 
local trash = {
    used = {};
    models = { 
        [ 1] = 1264, 
        [ 2] = 1265,
        [ 3] = 1230
    },
    Object = {
        -- weapons
        [ 1] = {type = "weapon", id =  1, ammo =  1},
        [ 2] = {type = "weapon", id =  4, ammo =  1},
        [ 3] = {type = "weapon", id = 10, ammo =  1},
        [ 4] = {type = "weapon", id = 11, ammo =  1},  
        [ 5] = {type = "weapon", id = 12, ammo =  1}, 
        [ 6] = {type = "weapon", id = 13, ammo =  1},   
        [ 7] = {type = "weapon", id = 14, ammo =  1}, 
        [ 8] = {type = "weapon", id = 41, ammo = 30},
        -- objects
        [ 9] = {type = "object", model = 2881, hand=1, action="GiveHealt(20);", IFP ="FOOD", Animation = "EAT_Burger"},
        [10] = {type = "object", model = 2601, hand=0, action="GiveHealt(10);", IFP ="VENDING", Animation = "VEND_Drink_P"},
        [11] = {type = "object", model = 2880, hand=1, action="GiveHealt(15);", IFP ="FOOD", Animation = "EAT_Burger"},
    }   
}

function LoadModel(m)
    if not hasModelLoaded(m) then 
        requestModel(m); loadAllModelsNow();
    end
    return hasModelLoaded(m);
end

function GiveWeapon(weapon, ammo)
    local m = getWeapontypeModel(weapon); 
    if LoadModel(m) then 
        if ammo == nil then ammo = 1 end;
        giveWeaponToChar(PLAYER_PED, weapon, ammo);
    end
end

function GiveHealt(v)
    local h = getCharHealth(PLAYER_PED); 
    if h <= MaxHealt then 
        setCharHealth(PLAYER_PED, h + v)
    end
end

function LoadAnimation(ifp)
    if not hasAnimationLoaded(ifp) then 
        requestAnimation(ifp);
        loadAllModelsNow();
    end 
    return hasAnimationLoaded(ifp);
end

function FindObjectsInTrash(v)
    if trash.Object[v] then 
        local t = trash.Object[v].type;
        if t == "weapon" then 
            GiveWeapon(trash.Object[v].id , trash.Object[v].ammo);
        elseif t == "object" then
            local m = trash.Object[v].model;
            if LoadModel(m) then
                local IFP = trash.Object[v].IFP;
                local Animation = trash.Object[v].Animation;
                local Item = createObject(m,0.0,0.0,0.0);
                taskPickUpObject(PLAYER_PED, Item, 0.0, 0.0, 0.0, (trash.Object[v].hand + 5), 16, "NULL", "NULL", 0);
                requestAnimation(IFP);
                taskPlayAnim(PLAYER_PED, Animation, IFP, 1.0, false, true, true, false, -1);
                wait(1);
                while isCharPlayingAnim(PLAYER_PED, Animation) do 
                    local pos = getCharAnimCurrentTime(PLAYER_PED,Animation);
                    if pos >= 0.6 then 
                        if doesObjectExist(Item) then deleteObject(Item) end;
                    end
                    wait(0);
                end
                if trash.Object[v].action then
                    loadstring(trash.Object[v].action)();
                end
                removeAnimation(IFP);
                if doesObjectExist(Item) then deleteObject(Item) end;
            end
        end
    end
    return false;
end

function main()
    MaxHealt = getCharHealth(PLAYER_PED);
    repeat 
        if isButtonPressed(PLAYER_HANDLE, 11) then
            local x, y, z = getOffsetFromCharInWorldCoords(PLAYER_PED, 0.0, 0.65, 0.0);
            local result, object = findAllRandomObjectsInSphere(x, y, z, 0.75, false);
            if result then 
                local m = getObjectModel(object); 
                if not trash.used[object] then
                    for i=1, #trash.models do 
                        if trash.models[i] == m then
                            local Checked = false;
                            setCurrentCharWeapon(PLAYER_PED, 0);
                            setObjectCollision(object, false);                            
                            if LoadAnimation("BOMBER") then
                                taskPlayAnim(PLAYER_PED, "BOM_Plant", "BOMBER", 4.0, false, true, true, false, -1);
                                wait(1);
                            end
                            while isCharPlayingAnim(PLAYER_PED, "BOM_Plant") do 
                                local pos = getCharAnimCurrentTime(PLAYER_PED, "BOM_Plant");
                                local result, ped = findAllRandomCharsInSphere(x, y, z, 5.0, false, true);
                                if result then 
                                    taskTurnCharToFaceChar(ped, PLAYER_PED);
                                end
                                if pos >= 0.4 and not Checked then
                                    math.randomseed(os.clock());
                                    FindObjectsInTrash(math.random(1, #trash.Object));
                                    Checked = true
                                end
                                wait(0);
                            end
                            setObjectCollision(object, true);
                            clearCharTasks(PLAYER_PED);
                            trash.used[object] = true;
                        end
                    end
                else 
                    printStringNow("Este lixo ja foi revirado", 3000);
                end
            end
            while isButtonPressed(PLAYER_handLE, 11) do wait(0) end;
        end
        wait(20); 
    until false
end